#!/usr/bin/perl -w
#
# GDA.pm
#
# $Revision: 1.1.1.1 $
#
# TODO:
#
#   * Don't hardcode the app name, etc. in init().
#
# Copyright (C) 2001 Gregor N. Purdy. All rights reserved.
#
# This program is free software. It may be modified and/or
# distributed under the same terms as Perl itself.
#

use strict;

package GDA;

use Carp;

use vars qw($VERSION);
$VERSION = '0.1';

use Inline 'C';

use Inline 'C' => Config =>
  INC          => '-I/usr/include/gda -I/usr/include/glib-1.2 -I/usr/lib/glib/include -I/usr/include/gtk-1.2 -I/usr/include/gnome-xml',
  AUTO_INCLUDE => '#include "gda-config.h"',
  LIBS         => '-lgda-common';

  Inline->init;

my $imported = 0;

sub import
{
  my $package = shift;

  return if $imported;

  croak "GDA.pm: usage: use GDA <app>, <ver>, ...;\n"
    . "  Caller did: use GDA " . join(', ', map { "'$_'" } @_) . ";\n"
    . "  (If this message is for a GDA::* module, perhaps you forgot to\n"
    . "  'use GDA ...' in your main program?)"  unless @_ >= 2;

  my $app = shift;
  my $ver = shift;

  my $prog;

  if (@_) {
    $prog = shift;
  } else {
    $prog = $0;
  }
 
  # TODO: Why were we getting undefs in the first place ('under make test')?

  $app  = '<undef>' if not defined $app;
  $ver  = '<undef>' if not defined $ver;
  $prog = '<undef>' if not defined $prog;

  init($app, $ver, $prog);
  $imported++;
}

sub imported
{
  return $imported;
}

1;

__DATA__
__C__


void init(char * app, char * ver, char * prog)
{
  int argc = 1;
  char * argv [] = { prog, NULL };

  gda_init(app, ver, argc, argv); /* TODO: Who owns these strings? */
}


/*
** EOF
*/

